/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.email.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.email.entity.EmailVorlage;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class EmailVorlageExtendedDAO extends AbstractEmailVorlageDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: AllNoFlush<br>
* Beschreibung: <br>
* EJBQL: select o from EmailVorlage o<br>
* SQL: <br>
*/
@Override
public java.util.List<EmailVorlage> findByAll() {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("EmailVorlage.findByAll"  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByAll(): Miss");
        }

        cache.put(key, super.findByAll( ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByAll(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<EmailVorlage>) cache.lookup(key));
    }

    return super.findByAll( );
}
/**
* Name: CountEmailLayoutNoFlush<br>
* Beschreibung: <br>
* EJBQL: select count(o) from EmailVorlage o where o.emailLayout=?1<br>
* SQL: <br>
*/
@Override
public java.lang.Long findByCountEmailLayout( @javax.annotation.Nonnull de.ivu.elect.business.email.entity.EmailLayout emailLayout) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("EmailVorlage.findByCountEmailLayout" ,  emailLayout  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByCountEmailLayout(): Miss");
        }

        cache.put(key, super.findByCountEmailLayout( emailLayout  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByCountEmailLayout(): Hit");
      }

      return (java.lang.Long) cache.lookup(key);
    }

    return super.findByCountEmailLayout( emailLayout  );
}
/**
* Name: WahlOrderByBezeichnungNoFlush<br>
* Beschreibung: <br>
* EJBQL: select o from EmailVorlage o where o.wahl=?1 order by o.bezeichnung<br>
* SQL: <br>
*/
@Override
public java.util.List<EmailVorlage> findByWahlOrderByBezeichnung( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("EmailVorlage.findByWahlOrderByBezeichnung" ,  wahl  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlOrderByBezeichnung(): Miss");
        }

        cache.put(key, super.findByWahlOrderByBezeichnung( wahl  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlOrderByBezeichnung(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<EmailVorlage>) cache.lookup(key));
    }

    return super.findByWahlOrderByBezeichnung( wahl  );
}
/**
* Name: WahlterminOrderByBezeichnungNoFlush<br>
* Beschreibung: <br>
* EJBQL: select o from EmailVorlage o where o.wahltermin=?1 order by o.bezeichnung<br>
* SQL: <br>
*/
@Override
public java.util.List<EmailVorlage> findByWahlterminOrderByBezeichnung( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("EmailVorlage.findByWahlterminOrderByBezeichnung" ,  wahltermin  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlterminOrderByBezeichnung(): Miss");
        }

        cache.put(key, super.findByWahlterminOrderByBezeichnung( wahltermin  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlterminOrderByBezeichnung(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<EmailVorlage>) cache.lookup(key));
    }

    return super.findByWahlterminOrderByBezeichnung( wahltermin  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
